All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
CustomGBForceImpl Class Reference

This is the internal implementation of CustomGBForce. More...

`#include <CustomGBForceImpl.h>`

Inheritance diagram for CustomGBForceImpl:

## Public Member Functions

| CustomGBForceImpl (const CustomGBForce &owner)
| ~CustomGBForceImpl ()
void | initialize (ContextImpl &context)
| This is called after the ForceImpl is created and before updateContextState(), calcForces(), or calcEnergy() is called on it. More...
const CustomGBForce & | getOwner () const
| Get the Force object from which this ForceImpl was created. More...
void | updateContextState (ContextImpl &context)
| This method is called at the beginning of each time step. More...
double | calcForcesAndEnergy (ContextImpl &context, bool includeForces, bool includeEnergy, int groups)
| Calculate the force on each particle generated by this ForceImpl and/or this ForceImpl's contribution to the potential energy of the system. More...
std::map< std::string, double > | getDefaultParameters ()
| Get a map containing the default values for all adjustable parameters defined by this ForceImpl. More...
std::vector< std::string > | getKernelNames ()
| Get the names of all Kernels used by this Force. More...
void | updateParametersInContext (ContextImpl &context)
Public Member Functions inherited from ForceImpl
virtual | ~ForceImpl ()
virtual std::vector< std::pair < int, int > > | getBondedParticles () const
| Get pairs of particles connected by bonds by this force. More...

## Detailed Description

This is the internal implementation of CustomGBForce.

## Constructor & Destructor Documentation

CustomGBForceImpl | ( | const CustomGBForce & | owner | ) |

~CustomGBForceImpl | ( |  | ) |

## Member Function Documentation

double calcForcesAndEnergy | ( | ContextImpl & | context,
|  | bool | includeForces,
|  | bool | includeEnergy,
|  | int | groups
| ) |  |

virtual

Calculate the force on each particle generated by this ForceImpl and/or this ForceImpl's contribution to the potential energy of the system.

Parameters

  context | the context in which the system is being simulated
  includeForces | true if forces should be calculated
  includeEnergy | true if the energy should be calculated
  groups | a set of bit flags for which force groups to include. Group i should be included if (groups&(1<<i)) != 0.

Returns
  this force's contribution to the potential energy of the system, or 0 if this force does not contribute to potential energy (or if includeEnergy is false)

Implements ForceImpl.

std::map<std::string, double> getDefaultParameters | ( |  | ) |

virtual

Get a map containing the default values for all adjustable parameters defined by this ForceImpl.

These parameters and their default values will automatically be added to the Context.

Implements ForceImpl.

std::vector<std::string> getKernelNames | ( |  | ) |

virtual

Get the names of all Kernels used by this Force.

Implements ForceImpl.

const CustomGBForce& getOwner | ( |  | ) | const

inlinevirtual

Get the Force object from which this ForceImpl was created.

Implements ForceImpl.

void initialize | ( | ContextImpl & | context | ) |

virtual

This is called after the ForceImpl is created and before updateContextState(), calcForces(), or calcEnergy() is called on it.

This allows it to do any necessary initialization.

Implements ForceImpl.

void updateContextState | ( | ContextImpl & | context | ) |

inlinevirtual

This method is called at the beginning of each time step.

It give the ForceImpl a chance to modify the state variables (positions, velocities, and parameters) stored in the Context in arbitrary ways before integration is performed.

Parameters

  context | the context in which the system is being simulated

Implements ForceImpl.

void updateParametersInContext | ( | ContextImpl & | context | ) |

The documentation for this class was generated from the following file:

- CustomGBForceImpl.h